﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Windows.Forms;

public partial class Monitor : System.Web.UI.Page
{
    private bool isBoolTrue = true;
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            //memanggil fungsi distributor 
            TampilDistributor();
            //Memilih data pertama pada DropDownlist
            DropDownList1.SelectedIndex = 0;
        }
    }
    protected void Button2_Click(object sender, EventArgs e)
    {
        //clearTextbox();
    }
    private void clearTextbox()
    {
        txtNamaBarang.Text = "";
        txtHarga.Text = "";
        txtStok.Text = "";
    }
    private void TampilDistributor()
    {
        //mengambil connection string dari Web.config
        string SuryoCon = ConfigurationManager.ConnectionStrings["SuryoConnection"].ConnectionString;
        //membuat koneksi
        SqlConnection con = new SqlConnection(SuryoCon);
        try
        {
            //membuka koneksi
            con.Open();
            //mengisi perintah ke dalam command
            SqlCommand com = new SqlCommand("select * from msdistributor", con);
            //membuat objek SqlDataReader
            SqlDataReader rd;
            //membaca data dari command
            rd = com.ExecuteReader();
            //membaca data hingga data habis
            while (rd.Read())
            {
                //membuat list item untuk menyimpan data
                ListItem DaftarItem = new ListItem();
                //menampilkan data distributor ke dalam dropdownlist
                //daftar Item yang ditampilkan
                DaftarItem.Text = rd["NamaDistributor"].ToString();
                //daftar item yang akan menjadi value
                DaftarItem.Value = rd["KdDistributor"].ToString();
                //add item ke dalam dropdownlist
                DropDownList1.Items.Add(DaftarItem);
            }
            //tutup datareader
            rd.Close();
            //hapus objek datareader
            rd.Dispose();
        }
        catch (Exception kesalahan)
        {
            MessageBox.Show(kesalahan.ToString());
        }
        finally
        {
            //tutup koneksi dan hapus koneksi
            con.Close();
            con.Dispose();
        }
    }

    private void CekString(string TerimaNilai, string TerimaPesan)
    {
        //integer i disini sebagai penyimpan nilai dan pembanding
        int i;
        //buat tipe data boolean yang akan menyimpan hasil
        //cara kerja dari int.TryParse adalah :
        //mencoba konversi data yang di terima yang berformat string
        //dan di coba konversi ke dalam Integer ( out i )
        //kemudian bila dapat di konversi ke integer
        //berarti True dan hasil akan di simpan ke variabel result
        bool result = int.TryParse(TerimaNilai, out i);
        if (!result)
        {
            MessageBox.Show(TerimaPesan);
            isBoolTrue = false;
        }
        else
        {
            isBoolTrue = true;
        }
    }
    private void CekDataPadaDatabase(string TerimaNilai, string TerimaPesan)
    {
        string SuryoCon = ConfigurationManager.ConnectionStrings["SuryoConnection"].ConnectionString;
        SqlConnection con = new SqlConnection(SuryoCon);
        try
        {
            int i ;
            con.Open();
            SqlCommand com = new SqlCommand("select count(namabarang) from msbarang where namabarang = '" + TerimaNilai + "'",con);
            //execute scalar digunakan untuk menghitung aggregate function
            //yang hanya membalikkan 1 nilai seperti max , min , count , avg
            i = Convert.ToInt16(com.ExecuteScalar());
            //bila i > 0 berarti maksudnya disini data itu 
            //sudah ada pada database
            //maka tampilkan pesan bahwa data sudah ada 
            if ( i > 0 )
            {
                MessageBox.Show(TerimaPesan);
                isBoolTrue = false;
            }
            else
            {
                isBoolTrue = true;
            }
            com.Dispose();
        }
        catch (Exception kesalahan)
        {
            MessageBox.Show(kesalahan.ToString());
        }
        finally
        {
            con.Close();
            con.Dispose();        
        }
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        //tidak boleh ada data yang kosong
        if (txtNamaBarang.Text.Trim() == "" || txtStok.Text.Trim() == "" || txtHarga.Text.Trim() == "")
        {
            MessageBox.Show("tidak boleh ada kolom kosong");
            return; 
        }
        //cek harga dan stok mesti number
        CekString(txtHarga.Text.Trim(), "Harga Mesti Number");
        if (!isBoolTrue) return;
        CekString(txtStok.Text.Trim(), "Stok Mesti Number");
        if (!isBoolTrue) return;

        //cek namabarang tidak boleh ada pada database
        CekDataPadaDatabase(txtNamaBarang.Text.Trim(), "Nama Barang Sudah ada");
        if (!isBoolTrue) return;

        string SuryoCon = ConfigurationManager.ConnectionStrings["SuryoConnection"].ConnectionString;
        SqlConnection con = new SqlConnection(SuryoCon);
        try
        {
            con.Open();
            //bila checkbox di centang atau bernilai true
            //lakukan perintah dalam if untuk melakukan insert data dengan paramter
            if (CheckBox1.Checked)
            {
                //buat string queryInsert untuk melakukan insertData
                //parameter diawali dengan lambang @
                string queryInsert = "insert into msbarang(NamaBarang,Stok,Harga , KdDistributor)" +
                "values(@p_nama ,@p_stok , @p_harga , @p_dis)";
                SqlCommand com = new SqlCommand(queryInsert, con);
                //isi parameter dengan value 
                com.Parameters.AddWithValue("@p_nama" , txtNamaBarang.Text.Trim());
                com.Parameters.AddWithValue("@p_stok" , txtStok.Text.Trim() );
                com.Parameters.AddWithValue("@p_harga", txtHarga.Text.Trim() );
                com.Parameters.AddWithValue("@p_dis", DropDownList1.SelectedValue);
                //jalankan / eksekusi perintah 
                com.ExecuteNonQuery();   
            }
            else
            {
                SqlCommand com = new SqlCommand("insert into msbarang(NamaBarang,Stok,Harga,KdDistributor) values('" + txtNamaBarang.Text.Trim() + "' ,'" + txtStok.Text.Trim() + "' , '" + txtHarga.Text.Trim() + "' , "+ DropDownList1.SelectedValue +" )", con);
                com.ExecuteNonQuery();   
            }
        }
        catch (Exception kesalahan)
        {
            MessageBox.Show(kesalahan.ToString());
        }
        finally
        {
            MessageBox.Show("Insert Data sukses");
            con.Close();
            con.Dispose();
        }
    }

}
