﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;
using System.Windows.Forms;

public partial class Support : System.Web.UI.Page
{
    private string SuryoCon = ConfigurationManager.ConnectionStrings["SuryoConnection"].ConnectionString;
    SqlDataAdapter da;
    DataSet ds;
    SqlCommand com = new SqlCommand();

    private void panggilData()
    {
        SqlConnection con = new SqlConnection(SuryoCon);
        try
        {
            com.CommandText = "select * from msbarang";
            com.Connection = con;
            da = new SqlDataAdapter(com);
            ds = new DataSet();
            //fill data ke dalam ds barang
            da.Fill(ds, "barang");
            com.CommandText = "select * from msdistributor";
            //fill data ke dalam ds distributor
            da.Fill(ds, "distributor");
            //membuat DataColumn
            DataColumn parentChild = ds.Tables["barang"].Columns["KdDistributor"];
            DataColumn parentColumn = ds.Tables["distributor"].Columns["KdDistributor"];
            //membuat dataRelation
            DataRelation relasiParent;
            //mendefinisikan isi dari dataRelation
            //perlu kita perhatikan disini
            //"NewOrder" merupakan relation name
            //kemudian kolom ke 2 merupakan column di mana primary key berada
            //dan kolom  ke 3 merupakan foreign key yg menunjuk PK,
            //bila anda salah meletakkan akan menyebabkan error
            relasiParent = new DataRelation("NewOrder", parentColumn, parentChild);
            //membuat relasi
            ds.Relations.Add(relasiParent);
         
            //menentukan datasource, data member
            //kemudian membinding data
            GridView1.DataSource = ds;
            GridView1.DataMember = "barang";
            GridView1.DataBind();
            GridView2.DataSource = ds;
            GridView2.DataMember = "distributor";
            GridView2.DataBind();
            //menutup koneksi
            con.Close();
        }
        catch (Exception kesalahan)
        {
            MessageBox.Show(kesalahan.ToString());
        }
        finally
        {
            con.Dispose();
        }
    }
    
    protected void Page_Load(object sender, EventArgs e)
    {
        //memanggil function panggilData
        panggilData();

        //mengganti isi dari nama barang pd ds.tables[0] merupakan indeks dimana
        //data table yang pertama kali dibuat , yaitu Tables Barang
        //, dan tables distributor menjadi indeks ke 1 karena 
        //diadd setelah tables barang

        ds.Tables[0].Rows[2]["NamaBarang"] = "Suryo";
        LabelHeader.Text = "data pada data set barang pada data ke 2 sebelumnya : " + ds.Tables[0].Rows[2]["NamaBarang"].ToString() + "<br/>";
        ds.Tables[0].Rows[2]["NamaBarang"] = "SuryoDesign";
        LabelHeader.Text += "data pada data set barang pada data ke 2 saat ini   : " + ds.Tables[0].Rows[2]["NamaBarang"].ToString() + "<br/>";
        LabelHeader.Text += "<br/>Nama Kolom yang ada pada table Distributor : <br/>";
        int i = 1;
        //membaca column yang ada pada Tables distributor
        foreach (DataColumn column in ds.Tables["distributor"].Columns)
        {
            LabelHeader.Text += "Kolom ke : " + i + " adalah : " + column.ColumnName + "<br/>";
            i++;
        }
            //membuat tables baru pada dataset
            ds.Tables.Add("Artis");
            //buat column baru pada dataset
            ds.Tables["Artis"].Columns.Add("Nama");
            ds.Tables["Artis"].Columns.Add("Daerah");

            //mendefinisikan data row dan membuat row baru 
            DataRow rowBaru = ds.Tables["Artis"].NewRow();
             //mengisi row baru dengan data yang ada
            rowBaru["Nama"] = "Suryo";
            rowBaru["Daerah"] = "Lampung";
            ds.Tables["Artis"].Rows.Add(rowBaru);

            rowBaru = ds.Tables["Artis"].NewRow();
            rowBaru["Nama"] = "Design";
            rowBaru["Daerah"] = "Jakarta";
            ds.Tables["Artis"].Rows.Add(rowBaru);

            rowBaru = ds.Tables["Artis"].NewRow();
            rowBaru["Nama"] = "Ario";
            rowBaru["Daerah"] = "Jawa";
            ds.Tables["Artis"].Rows.Add(rowBaru);

            rowBaru = ds.Tables["Artis"].NewRow();
            rowBaru["Nama"] = "Creative";
            rowBaru["Daerah"] = "Bandung";
            ds.Tables["Artis"].Rows.Add(rowBaru);

            //binding data dari dataset yang baru dibuat 
            //ke dalam listbox
            ListBox1.DataSource = ds.Tables["Artis"];
            ListBox1.DataTextField = "Nama";
            ListBox1.DataBind();
            
            //membuat arraylist
            ArrayList artis = new ArrayList();
            artis.Add("titi kamal");
            artis.Add("asmiranda");
            artis.Add("sheila");
            artis.Add("marshanda");
            artis.Add("leoni");
            artis.Add("baby");
            
            //binding arrayList ke dalam dropDownList
            DropDownList1.DataSource = artis;
            DropDownList1.DataBind();
    }
}
